
import java.util.ArrayList;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.Queue;
import java.util.Scanner;

/**
 *
 * @author cteam045
 */
public class Karel {

    private static void solve(boolean[][] isZed, int eR, int eS, char[] tmp) {
        char[] prikazy = new char[tmp.length];
        for (int i = 0; i < prikazy.length; i++) {
            prikazy[i] = tmp[prikazy.length - 1 - i];
            if (prikazy[i] == 'R') {
                prikazy[i] = 'L';
            } else if (prikazy[i] == 'L') {
                prikazy[i] = 'R';
            }
        }
        //solution
        int neededCount = isZed.length * isZed[0].length;
        for (boolean[] i : isZed) {
            for (boolean j : i) {
                if (j) {
                    neededCount--;
                }
            }
        }
        Queue<State> q = new LinkedList<State>();
        q.add(new State(new Position(eR, eS), Direction.UP));
        q.add(new State(new Position(eR, eS), Direction.RIGHT));
        q.add(new State(new Position(eR, eS), Direction.DOWN));
        q.add(new State(new Position(eR, eS), Direction.LEFT));
        boolean[][] possible = new boolean[isZed.length][isZed[0].length];
        possible[eR][eS] = true;
        HashSet<State> achieved = new HashSet<State>();
        achieved.add(new State(new Position(eR, eS), Direction.UP));
        achieved.add(new State(new Position(eR, eS), Direction.RIGHT));
        achieved.add(new State(new Position(eR, eS), Direction.DOWN));
        achieved.add(new State(new Position(eR, eS), Direction.LEFT));
        while (!q.isEmpty()) {
            State state = q.remove();
            System.out.println("removed " + state.toString());
            List<State> newStates = state.generateNext(isZed, prikazy);
            for (State s : newStates) {
                System.out.println("new state " + s.toString());
                if (achieved.contains(s)) {
                    continue;
                }
                achieved.add(s);
                q.add(s);
                possible[s.pos.radek][s.pos.sloupec] = true;
            }
        }
        int possibleCount = 0;
        for (boolean[] i : possible) {
            for (boolean j : i) {
                if (j) {
                    possibleCount++;
                }
            }
        }
        if (possibleCount == neededCount) {
            System.out.println("OK");
        } else {
            System.out.println(possibleCount);
        }
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int vyska, sirka;
        while (sc.hasNextInt()) {
            vyska = sc.nextInt();
            sirka = sc.nextInt();
            String line;
            sc.nextLine();
            boolean[][] isZed = new boolean[vyska][sirka];//radek / sloupec
            int eR = 0, eS = 0;
            for (int i = 0; i < vyska; i++) {
                line = sc.nextLine();
                for (int j = 0; j < sirka; j++) {
                    if (line.charAt(j) == 'X') {
                        isZed[i][j] = true;
                    } else {
                        if (line.charAt(j) == 'E') {
                            eR = i;
                            eS = j;
                        }
                    }
                }
            }
            int pocetPrikazu = sc.nextInt();
            sc.nextLine();
            line = sc.nextLine();
            char[] prikazy = line.toCharArray();
            solve(isZed, eR, eS, prikazy);
        }

    }

    private static enum Direction {

        UP, RIGHT, DOWN, LEFT;

        public Direction apply(char command) {
            if (command == 'S') {
                return this;
            }
            switch (this) {
                case UP:
                    if (command == 'L') {
                        return LEFT;
                    } else {
                        return RIGHT;
                    }
                case RIGHT:
                    if (command == 'L') {
                        return UP;
                    } else {
                        return DOWN;
                    }
                case DOWN:
                    if (command == 'L') {
                        return RIGHT;
                    } else {
                        return LEFT;
                    }
                default:
                    if (command == 'L') {
                        return DOWN;
                    } else {
                        return UP;
                    }
            }
        }
    }

    private static class Position {

        private int radek;
        private int sloupec;

        public Position(int radek, int sloupec) {
            this.radek = radek;
            this.sloupec = sloupec;
        }

        public List<Position> goTo(boolean[][] isWall, Direction dir) {
            int newRadek = radek;
            int newSloupec = sloupec;
            switch (dir) {
                case UP:
                    newRadek--;
                    break;
                case RIGHT:
                    newSloupec++;
                    break;
                case DOWN:
                    newRadek++;
                    break;
                case LEFT:
                    newSloupec--;
                    break;
            }
            List<Position> res = new ArrayList<Position>();
            if (newRadek < 0 || newSloupec < 0 || newRadek >= isWall.length || newSloupec >= isWall[0].length) {
                res.add(new Position(radek, sloupec));
                return res;
            }
            if (isWall[newRadek][newSloupec]) {
                res.add(new Position(radek, sloupec));
                return res;
            }
            res.add(new Position(newRadek, newSloupec));
            switch (dir) {
                case UP:
                    if (radek + 1 >= isWall.length || isWall[radek + 1][sloupec]) {
                        res.add(new Position(radek, sloupec));
                    }
                    break;
                case RIGHT:
                    if (sloupec - 1 < 0 || isWall[radek][sloupec - 1]) {
                        res.add(new Position(radek, sloupec));
                    }
                    break;
                case DOWN:
                    if (radek - 1 < 0 || isWall[radek - 1][sloupec]) {
                        res.add(new Position(radek, sloupec));
                    }
                    break;
                case LEFT:
                    if (sloupec + 1 >= isWall[0].length || isWall[radek][sloupec + 1]) {
                        res.add(new Position(radek, sloupec));
                    }
                    break;
            }
            return res;
        }

        @Override
        public boolean equals(Object obj) {
            if (obj == null) {
                return false;
            }
            if (getClass() != obj.getClass()) {
                return false;
            }
            final Position other = (Position) obj;
            if (this.radek != other.radek) {
                return false;
            }
            if (this.sloupec != other.sloupec) {
                return false;
            }
            return true;
        }

        @Override
        public int hashCode() {
            int hash = 3;
            hash = 83 * hash + this.radek;
            hash = 83 * hash + this.sloupec;
            return hash;
        }

        @Override
        public String toString() {
            return "Position{" + "radek=" + radek + ", sloupec=" + sloupec + '}';
        }
    }

    private static class State {

        private Position pos;
        private Direction d;

        public State(Position pos, Direction d) {
            this.pos = pos;
            this.d = d;
        }

        @Override
        public boolean equals(Object obj) {
            if (obj == null) {
                return false;
            }
            if (getClass() != obj.getClass()) {
                return false;
            }
            final State other = (State) obj;
            if (this.pos != other.pos && (this.pos == null || !this.pos.equals(other.pos))) {
                return false;
            }
            if (this.d != other.d) {
                return false;
            }
            return true;
        }

        @Override
        public int hashCode() {
            int hash = 5;
            hash = 71 * hash + (this.pos != null ? this.pos.hashCode() : 0);
            hash = 71 * hash + (this.d != null ? this.d.hashCode() : 0);
            return hash;
        }

        public List<State> generateNext(boolean[][] isZed, char[] prikazy) {
            List<State> tmp = new ArrayList<State>();
            tmp.add(this);
            for (int i = 0; i < prikazy.length; i++) {
                List<State> tmp2 = new ArrayList<State>();
                for (State s : tmp) {
                    if (prikazy[i] == 'S') {
                        List<Position> pos = s.pos.goTo(isZed, s.d);
                        for (Position p : pos) {
                            tmp2.add(new State(p, s.d));
                        }
                    } else {
                        tmp2.add(new State(s.pos, s.d.apply(prikazy[i])));
                    }
                }
                tmp = tmp2;
            }
            return tmp;
        }

        @Override
        public String toString() {
            return "State{" + "pos=" + pos + ", d=" + d + '}';
        }
    }
}
